@if (vm$ | async; as vm) {
  <jds-bi-hosted-dropdown
    [(open)]="isOpen"
    [jdsBiDropdownLimitWidth]="dropdownLimitWidth"
    [content]="dropdown"
    [jdsBiDropdownAlign]="'right'"
    [jdsBiDropdownMinWidth]="512"
    [jdsBiDropdownMaxHeight]="668"
  >
    <button
      [ngClass]="[
        jds.button,
        jds.text('gray800'),
        jds.px(0),
        jds.mt(2),
        jds.ms(0),
        jds.msMd(22),
        jds.pos('relative'),
        jds.top(-1.25)
      ]"
      (click)="onOpen()"
      type="button"
    >
      <svg
        width="17"
        height="17"
        viewBox="0 0 17 17"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          d="M8.82727 16.5925C9.86256 16.5925 10.7096 15.8459 10.7096 14.9333H6.94492C6.94492 15.8459 7.79198 16.5925 8.82727 16.5925ZM14.9449 11.6148V7.05179C14.9449 4.47994 12.9684 2.40587 10.239 1.82512V1.24438C10.239 0.58068 9.58021 -6.10352e-05 8.82727 -6.10352e-05C8.07433 -6.10352e-05 7.41551 0.58068 7.41551 1.24438V1.82512C4.68609 2.40587 2.70962 4.47994 2.70962 7.05179V11.6148L0.827271 13.274V14.1036H16.8273V13.274L14.9449 11.6148Z"
          fill="currentColor"
        />
      </svg>
    </button>

    @if (vm.countNotification; as countNotification) {
      @switch (countNotification.status) {
        @case ('success') {
          @if (countNotification.data.count_notif > 0) {
            <span
              [ngClass]="[
                jds.badge,
                jds.bg(jdsBiColor.red['600']),
                jds.rounded('pill'),
                jds.pos('relative'),
                jds.top(-10),
                jds.left(-5)
              ]"
            >
              @if (countNotification.data.count_notif < 100) {
                {{ countNotification.data.count_notif }}
              } @else {
                {{ '99+' }}
              }
            </span>
          }
        }
      }
    }
  </jds-bi-hosted-dropdown>

  <ng-template #dropdown>
    <!-- Card Header -->
    <div [ngClass]="[jds.pt(16), jds.pb(8), jds.px(24)]">
      <span [ngClass]="[jds.fs(16), jds.fw('bold')]">Notifikasi</span>
    </div>

    <!-- Card Nav -->
    <ul
      #nav="jdsBiNav"
      [(activeId)]="vm.filterType"
      [colorScheme]="colorScheme"
      [ngClass]="[jds.alignItems('end'), jds.justifyContent('center')]"
      jdsBiNav
      variant="ghost"
    >
      <li [jdsBiNavItem]="'upload-change'">
        <a
          [ngClass]="jds.textAlign('center')"
          (click)="onType('upload-change')"
          jdsBiNavLink
        >
          Permintaan <br />
          Unggah & Ubah
        </a>
      </li>
      <li [jdsBiNavItem]="'request-dataset'">
        <a
          [ngClass]="jds.textAlign('center')"
          (click)="onType('request-dataset')"
          jdsBiNavLink
        >
          Permohonan <br />
          Dataset
        </a>
      </li>
      <li [jdsBiNavItem]="'e-walidata'">
        <a
          [ngClass]="jds.textAlign('center')"
          (click)="onType('e-walidata')"
          jdsBiNavLink
        >
          E-Walidata
        </a>
      </li>
    </ul>

    <!-- Card Body -->
    <jds-bi-scrollbar [ngClass]="[jds.maxH(400)]">
      <div [ngClass]="[jds.py(4), jds.px(12)]">
        @if (vm.listNotification; as listNotification) {
          @switch (listNotification.status) {
            @case ('loading') {
              <ng-container *ngTemplateOutlet="skeleton" />
            }

            @case ('success') {
              @if (listNotification.data.list.length > 0) {
                @for (
                  item of listNotification.data.list;
                  track item.id;
                  let isLast = $last
                ) {
                  <div
                    [ngClass]="[
                      jds.fs(14),
                      jds.p(12),
                      jds.my(4),
                      jds.mx(0),
                      jds.rounded(10),
                      item.is_read ? jds.bg('white') : jds.bg('gray100')
                    ]"
                  >
                    @switch (item.feature) {
                      @case (2) {
                        <!-- Upload Change -->
                        @if (item.type === 'dataset') {
                          <span
                            [colorScheme]="'purple'"
                            [variant]="'subtle'"
                            [isRounded]="true"
                            [ngClass]="[
                              jds.py(0),
                              jds.px(5.5),
                              jds.mt(-4),
                              jds.me(5)
                            ]"
                            jdsBiBadge
                          >
                            Dataset
                          </span>
                        } @else if (item.type === 'mapset') {
                          <span
                            [colorScheme]="'red'"
                            [variant]="'subtle'"
                            [isRounded]="true"
                            [ngClass]="[
                              jds.py(0),
                              jds.px(5.5),
                              jds.mt(-4),
                              jds.me(5)
                            ]"
                            jdsBiBadge
                          >
                            Mapset
                          </span>
                        }
                        <span [innerHTML]="item.title"></span>
                        <span [innerHTML]="item.content"></span>
                        <div
                          [ngClass]="[
                            jds.d('flex'),
                            jds.alignItems('center'),
                            jds.mt(5)
                          ]"
                        >
                          <div>
                            {{
                              moment(item.cdate)
                                .locale('id')
                                .format('DD MMMM YYYY')
                            }}
                          </div>
                          <div [ngClass]="[jds.ms('auto')]">
                            <button
                              [disabled]="item.is_enable === false"
                              [colorScheme]="'green'"
                              (click)="
                                onRead(
                                  item.feature,
                                  item.type,
                                  item.type_id,
                                  item.title,
                                  item.notes
                                );
                                isOpen = false
                              "
                              jdsBiButton
                            >
                              Lihat
                            </button>
                          </div>
                        </div>
                      }
                      @case (3) {
                        <!-- Request Dataset Satu Data -->
                        <span
                          [innerHTML]="
                            getRequestDatasetPrivateContent(
                              item.title,
                              item.content
                            )
                          "
                        ></span>
                        <div
                          [ngClass]="[
                            jds.d('flex'),
                            jds.alignItems('center'),
                            jds.mt(5)
                          ]"
                        >
                          <div>
                            {{
                              moment(item.cdate)
                                .locale('id')
                                .format('DD MMMM YYYY')
                            }}
                          </div>
                          <div [ngClass]="[jds.ms('auto')]">
                            @if (satudataUser.role_name === 'walidata') {
                              <button
                                [disabled]="item.is_enable === false"
                                [colorScheme]="'green'"
                                (click)="
                                  onRequestDatasetPrivate(
                                    item.type,
                                    item.type_id
                                  );
                                  isOpen = false
                                "
                                jdsBiButton
                              >
                                Lihat
                              </button>
                            } @else {
                              <button
                                [ngClass]="[jds.button, jds.buttonPrimary]"
                                [colorScheme]="'blue'"
                                (click)="
                                  onRequestDatasetPrivate(
                                    item.type,
                                    item.type_id
                                  );
                                  isOpen = false
                                "
                                jdsBiButton
                              >
                                Lacak
                              </button>
                            }
                          </div>
                        </div>
                      }
                      @case (4) {
                        <!-- Request Dataset Open Data -->
                        <div
                          [innerHTML]="item.title + ' ' + item.content"
                        ></div>
                        <div
                          [ngClass]="[
                            jds.d('flex'),
                            jds.alignItems('center'),
                            jds.mt(5)
                          ]"
                        >
                          <div>
                            {{
                              moment(item.cdate)
                                .locale('id')
                                .format('DD MMMM YYYY')
                            }}
                          </div>
                          <div [ngClass]="[jds.ms('auto')]">
                            <button
                              [disabled]="item.is_enable === false"
                              [colorScheme]="'green'"
                              (click)="
                                onRead(item.feature, item.type, item.type_id);
                                isOpen = false
                              "
                              jdsBiButton
                            >
                              Lihat
                            </button>
                          </div>
                        </div>
                      }
                      @case (5) {
                        <!-- E-Walidata -->
                        <div
                          [innerHTML]="item.title + ' ' + item.content"
                        ></div>
                        <div
                          [ngClass]="[
                            jds.d('flex'),
                            jds.alignItems('center'),
                            jds.mt(5)
                          ]"
                        >
                          <div>
                            {{
                              moment(item.cdate)
                                .locale('id')
                                .format('DD MMMM YYYY')
                            }}
                          </div>
                          <div [ngClass]="[jds.ms('auto')]">
                            <button
                              [disabled]="item.is_enable === false"
                              [colorScheme]="'green'"
                              (click)="
                                onRead(item.feature, item.type, item.type_id);
                                isOpen = false
                              "
                              jdsBiButton
                            >
                              Lihat
                            </button>
                          </div>
                        </div>
                      }
                    }
                  </div>

                  @if (item.is_read && !isLast) {
                    <div [ngClass]="[jds.px(12)]">
                      <hr [ngClass]="[jds.m(0)]" />
                    </div>
                  }
                }
              } @else {
                <ng-container *ngTemplateOutlet="empty" />
              }
            }
          }
        }
      </div>
    </jds-bi-scrollbar>

    <!-- Card Footer -->
    <div
      [ngClass]="[jds.py(16), jds.px(24), jds.textAlign('center')]"
      [style.borderTop]="'1px solid #ddd'"
    >
      <a
        [ngClass]="[
          jds.fs(14),
          jds.text('primary'),
          jds.textDecoration('none')
        ]"
        [routerLink]="['/notification']"
        [queryParams]="{ type: vm.filterType }"
        (click)="isOpen = false"
      >
        Lihat semua notifikasi
      </a>
    </div>
  </ng-template>

  <app-modal-request-satudata-tracking
    [feature]="'navbar'"
    [notificationData]="vm.detailNotification"
    [historyData]="vm.historyRequestDatasetSatuData"
  />
}

<ng-template #skeleton>
  <div [ngClass]="jds.p(12)">
    @for (number of [100, 40, 60, 30]; track $index) {
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: number + '%',
            'border-radius': '0',
            height: '20px',
            'margin-bottom': '0'
          }"
        />
      </div>
    }
  </div>
</ng-template>

<ng-template #empty>
  <div
    [ngClass]="[
      jds.fs(14),
      jds.p(12),
      jds.my(4),
      jds.mx(0),
      jds.rounded(10),
      jds.textAlign('center')
    ]"
  >
    Belum ada notifikasi baru.
  </div>
</ng-template>
